#include <stdio.h>
#define n1  2048
#define n2  2048
#define n  n1*n2
#define f48  348         // max join_do_bias / flat file is 348
FILE  *fp,*fp1,*f[f48];		
char  head[72][80];
float a[n],bb[f48];
short ccd[n];
int   ip;

main(int ac,char **av)
{
  if(ac<2){
  printf("\n\t\t ******** 0key (max 348 fits)*********\n");
  printf("\n\t  raw_bias_data---> bias.fit  mode = median\n");
  printf("\n\t Usage:  lc0key !           jiang  20140103,0125\n\n");
  printf(" 1. automatic processing pipeline1 job, not answer any question.\n"); 
  printf(" 2. create a new directory, empty.\n");
  printf(" 3. copy raw_bias_files  (which you want using) to this directory\n");
  printf(" 4. in this directory, type command: lc0key !\n");
  printf(" 5. bias.fit is the result\n\n");
  exit(0);
  } 
  job_b4(); 
  work(a);
  system("mv lc0key.fit bias.fit");  
  printf("\toutput file: bias.fit   OK !\n");
} 

job_b4()
{
  int i,j,k; char a[60];
  float x,s;
  system("ls BIAS*.fit >1.1");
  fp=fopen("1.1","r"); ip=0;
l10:
  fgets(a,60,fp); if(feof(fp))goto l20;
  a[strlen(a)-1]=0;
  fp1=fopen(a,"rb"); fread(head,72,80,fp1); fread(ccd,n,2,fp1); fclose(fp1);
  printf("%3d: %s",ip+1,a);
  k=indexpos(head,"BITPIX  ",72);
  sscanf(&head[k][20],"%d",&j); if(j!=16){ printf("\tnot a raw file\n");
                                           exit(0); }
  k=indexpos(head,"NAXIS1  ",72);
  sscanf(&head[k][20],"%d",&j); if(j!=n1){ printf("\tnot a 50bin\n");
                                           exit(0); }
  sscanf(&head[k+1][20],"%d",&j); if(j!=n2){ printf("\tnot a 50bin\n");
                                           exit(0); }
  k=indexpos(head,"CCDTYPE ",72);
  if(head[k][11]!='B'){ printf("\tnot a bias file\n"); exit(0); }
  swap2(ccd,n*2);
  for(i=k=0;i<n;i++){ j=ccd[i]+32768; if(j>0 && j<32768)ccd[k++]=j; } 
  white_black(ccd,1,k,&x,&s); 
  printf("%9.2f\n",x);
  f[ip]=fopen(a,"rb"); fread(head,72,80,f[ip]); ip++; 
  goto l10;
l20:
  fclose(fp);  
  if(ip<4){ printf("less BIAS*.fit, at lest >= 4\n"); exit(0); }
}

work(float *a)
{
  float x,s; int i,j,k,l,m=0;
  for(i=0;i<58;i++)printf("-"); printf("\n");
  for(i=0;i<n2;i++){
    if(i%99==0){ printf("."); fflush(stdout); }
    for(j=0;j<ip;j++){ k=j*n1; fread(&ccd[k],2,n1,f[j]); }
    swap2(ccd,n1*ip*2);		
    for(j=0;j<n1;j++){
      l=j; for(k=0;k<ip;k++){  bb[k]=ccd[l]+32768; l+=n1; }
      sup_median(bb,ip,&x);
      a[m++] =x;
    }
  } for(j=0;j<ip;j++)fclose(f[j]); 

  strncpy(&head[1][27],"-32",3);	/* real*4 */
  k=0; for(i=0;i<n;i++)if(a[i]>0. && a[i]<32768.)ccd[k++]=a[i];
  white_black(ccd,1,k,&x,&s);
  k=indexpos(head,"END     ",72);
  head[k][0]=head[k][1]=head[k][2]=32;
  for(j= 5;j<=6;j++)for(i=0;i<80;i++)head[j][i]=32;
  head[71][0]='E'; head[71][1]='N'; head[71][2]='D'; 
  sprintf(head[k],"SKYADU  = %20.2f ",x);                 head[k++][31]='/';
  sprintf(head[k],"SUP_BIAS= %20d / biasfiles, _median",ip); head[k][51]=32;
  fp=fopen("lc0key.fit","wb");
  fwrite(head,72,80,fp); swap4(a,n*4); fwrite(a,4,n,fp);
  fclose(fp);
}
	
sup_median(a,nn,medi)
float *a,*medi; int nn;
{
  float x; int i,j;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if( *(a+i) > *(a+j)){
    x= *(a+i); *(a+i) = *(a+j); *(a+j)=x;
  } i=nn/2;
  *medi = (i+i==nn) ? (*(a+i) + *(a+i-1))*0.5 : *(a+i);
}
